/*
 *
 * Saryer.xs
 *
 * $Id: Saryer.xs,v 1.9 2000/12/18 04:32:42 knok Exp $
 *
 * Copyright: LGPL 
*/

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include "sary.h"

/* for old version of perl (< 5.004_04?) */
#if !defined(PL_na) && defined(na)
#define PL_na na
#endif
#if !defined(PL_sv_undef) && defined(sv_undef)
#define PL_sv_undef sv_undef
#endif

MODULE = Search::Saryer		PACKAGE = Search::Saryer

PROTOTYPES: DISABLE

SV *
perl_saryer_new(filename)
	char *filename

	PREINIT:
	Saryer *saryer;
	SV *sv;

	CODE:
	saryer = saryer_new(filename);
	if (saryer == NULL) {
		RETVAL = &PL_sv_undef;
	} else {
		sv = newSViv((IV) saryer);
		RETVAL = sv;
	}

	OUTPUT:
		RETVAL

void
perl_saryer_destroy(saryer)
	IV saryer

	PREINIT:
	Saryer *ps;

	CODE:
	ps = (Saryer *) saryer;
	saryer_destroy(ps);

void
perl_saryer_enable_cache(saryer)
	IV saryer

	PREINIT:
	Saryer *ps;

	CODE:
	ps = (Saryer *) saryer;
	saryer_enable_cache(ps);

SV *
perl_saryer_search(saryer, pat)
	IV saryer
	char *pat

	PREINIT:
	Saryer *ps;
	gboolean ret;

	CODE:
	ps = (Saryer *) saryer;
	ret = saryer_search(ps, pat);
	if (ret) {
		RETVAL = newSVnv(1);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

SV *
perl_saryer_icase_search(saryer, pat)
	IV saryer
	char *pat

	PREINIT:
	Saryer *ps;
	gboolean ret;

	CODE:
	ps = (Saryer *) saryer;
	ret = saryer_icase_search(ps, pat);
	if (ret) {
		RETVAL = newSVnv(1);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

SV *
perl_saryer_get_next_line(saryer)
	IV saryer

	PREINIT:
	Saryer *ps;
	char *ret;

	CODE:
	ps = (Saryer *) saryer;
	ret = saryer_get_next_line(ps);
	if (ret) {
		RETVAL = newSVpv(ret, 0);
		g_free(ret);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

SV *
perl_saryer_get_next_context_lines(saryer, bw, fw)
	IV saryer
	int bw
	int fw

	PREINIT:
	Saryer *ps;
	char *ret;

	CODE:
	ps = (Saryer *) saryer;
	ret = saryer_get_next_context_lines(ps, bw, fw);
	if (ret) {
		RETVAL = newSVpv(ret, 0);
		g_free(ret);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

SV *
perl_saryer_get_next_tagged_region(saryer, stag, etag)
	IV saryer
	char *stag
	char *etag

	PREINIT:
	Saryer *ps;
	char *ret;

	CODE:
	ps = (Saryer *) saryer;
	ret = saryer_get_next_tagged_region(ps, stag, etag);
	if (ret) {
		RETVAL = newSVpv(ret, 0);
		g_free(ret);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

void
perl_saryer_sort_occurrences(saryer)
	IV saryer

	PREINIT:
	Saryer *ps;

	CODE:
	ps = (Saryer *) saryer;
	saryer_sort_occurrences(ps);
